"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _e2eCommandHelper() {
  const data = _interopRequireDefault(require("./e2e-command-helper"));

  _e2eCommandHelper = function () {
    return data;
  };

  return data;
}

function _e2eBitJsonHelper() {
  const data = _interopRequireDefault(require("./e2e-bit-json-helper"));

  _e2eBitJsonHelper = function () {
    return data;
  };

  return data;
}

function _e2eScopes() {
  const data = _interopRequireDefault(require("./e2e-scopes"));

  _e2eScopes = function () {
    return data;
  };

  return data;
}

class ExtensionsHelper {
  constructor(scopes, command, bitJson) {
    this.scopes = scopes;
    this.command = command;
    this.bitJson = bitJson;
  }

  importAndConfigureExtension(id) {
    this.command.importExtension(id);
    const bitJson = this.bitJson.read(); // $FlowFixMe

    bitJson.extensions = {
      [id]: {}
    };
    this.bitJson.write(bitJson);
  }

  importNpmPackExtension(id = 'bit.extensions/npm/pack@2.0.1') {
    this.importAndConfigureExtension(id); // workaround to get the registry into the package.json file

    const extensionFilePath = _path().default.join(this.scopes.localPath, '.bit/components/npm/pack/bit.extensions/2.0.1/index.js');

    const extensionFile = _fsExtra().default.readFileSync(extensionFilePath).toString();

    const extensionFileIncludeRegistry = extensionFile.replace('excludeRegistryPrefix: true', 'excludeRegistryPrefix: false');
    const extensionFileWithJsonOutput = extensionFileIncludeRegistry.replace('return result;', 'return JSON.stringify(result, null, 2);');

    _fsExtra().default.writeFileSync(extensionFilePath, extensionFileWithJsonOutput);
  }

}

exports.default = ExtensionsHelper;