"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _e2eScopes() {
  const data = _interopRequireDefault(require("./e2e-scopes"));

  _e2eScopes = function () {
    return data;
  };

  return data;
}

class PackageJsonHelper {
  constructor(scopes) {
    this.scopes = scopes;
  }

  read(packageJsonFolder = this.scopes.localPath) {
    const packageJsonPath = _path().default.join(packageJsonFolder, 'package.json');

    return _fsExtra().default.readJSONSync(packageJsonPath) || {};
  }

  write(packageJson, packageJsonFolder = this.scopes.localPath) {
    const packageJsonPath = _path().default.join(packageJsonFolder, 'package.json');

    return _fsExtra().default.writeJSONSync(packageJsonPath, packageJson, {
      spaces: 2
    });
  }

  create(data, location = this.scopes.localPath) {
    const packageJsonPath = _path().default.join(location, 'package.json');

    _fsExtra().default.writeJSONSync(packageJsonPath, data, {
      spaces: 2
    });
  }

  corrupt(packageJsonPath = _path().default.join(this.scopes.localPath, 'package.json')) {
    _fsExtra().default.writeFileSync(packageJsonPath, '{ corrupted');
  }

  addKeyValue(data, pkgJsonPath = _path().default.join(this.scopes.localPath)) {
    const pkgJson = this.read(pkgJsonPath);

    _fsExtra().default.writeJSONSync(_path().default.join(pkgJsonPath, 'package.json'), Object.assign(pkgJson, data), {
      spaces: 2
    });
  }

  readComponentPackageJson(id) {
    const packageJsonFolderPath = _path().default.join(this.scopes.localPath, 'components', id);

    return this.read(packageJsonFolderPath);
  }

}

exports.default = PackageJsonHelper;