"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _os() {
  const data = _interopRequireDefault(require("os"));

  _os = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _e2eHelper() {
  const data = require("./e2e-helper");

  _e2eHelper = function () {
    return data;
  };

  return data;
}

class ScopesData {
  constructor() {
    this.e2eDir = _path().default.join(_os().default.tmpdir(), 'bit', 'e2e');
    this.setLocalScope();
    this.setRemoteScope();
    this.setEnvScope();
  }

  setLocalScope(localScope) {
    this.local = localScope || `${(0, _e2eHelper().generateRandomStr)()}-local`;
    this.localPath = _path().default.join(this.e2eDir, this.local);

    _fsExtra().default.ensureDirSync(this.localPath);
  }

  setRemoteScope() {
    this.remote = `${(0, _e2eHelper().generateRandomStr)()}-remote`;
    this.remotePath = _path().default.join(this.e2eDir, this.remote);
  }

  setEnvScope() {
    this.env = `${(0, _e2eHelper().generateRandomStr)()}-env`;
    this.envPath = _path().default.join(this.e2eDir, this.env);
  }

}

exports.default = ScopesData;